import 'package:flutter/cupertino.dart';
import 'package:osam/src/persist/persist_repository.dart';

abstract class Persist<ST, US> {
  factory Persist({@required String appName, @required int version}) =>
      PersistRepository<ST, US>(appName: appName, versionNumber: version);

  Future<void> init();

  Future<void> initPersist();

  Future<void> save({ST state, US uiState, int version});

  ST get getState;

  US get getUiState;

  Future<int> get version;

  Future<void> deleteHive();

  bool get isPersistEnabled;
}
